<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <style>
        /*
        Margenes para colocar la barra
        Width y height
        borde
        */
        .barra {
            margin-left: 40%;
            margin-top: 20%;
            width: 300px;
            border: 2px solid salmon;
            height: 50px;
        }

        /*
        Cambiamos el color de fondo
        Le ponemos un height del 100% para que ocupa todo el alto del padre
        Le ponemos una animación de 4 segundos
        */
        .progreso {
            background-color: salmon;
            animation: barraProgreso 4s infinite linear;
            height: 100%;
            /* Adapta el color al color de fondo*/
            mix-blend-mode: difference;
        }

        /*
        Creamos un pseudoelemento del texto con :: before
        El content se lo ponemos vacio por defecto
        Con la animación le cambiamos el contenido del texto
        line height y margin para posicionar el texto
        */

        #texto:before {
            content: '';
            line-height: 50px;
            margin-left: 140px;
            animation: textos 4s infinite linear;
            font-weight: bold;

        }

        /*
        Animación que cambia el ancho de la barra
        Cambaimso tambien el color del texto para que sea legible a medida que avanza la barra
        */
        @keyframes barraProgreso {

            /* Usando from y to (desde/ hasta)
            from {
                width: 0%;
            }

            to {
                width: 100%;
            }
            */

            0% {
                width: 0;
                color: salmon;
            }


            25% {
                width: 75px;
                color: salmon;
            }

            50% {
                width: 150px;
                color: salmon;
            }

            75% {
                width: 225px;
                color: black;
            }

            100% {
                width: 300px;
                color: black;
            }

        }

        /*
        Cambiamos el content de #texto::before
        Conseguimos que se vaya modificando el texto con el progeso de la barra
        */
        @keyframes textos {
            0% {
                content: '0%';
            }

            25% {
                content: '25%';
            }

            50% {
                content: '50%';
            }

            75% {
                content: '75%';
            }

            100% {
                content: '100%';
            }
        }
    </style>
</head>

<body>
    <div class="barra">
        <div class="progreso">
            <div id="texto"></div>
        </div>
    </div>
</body>

</html>